
//  Kalentereita.cs  (c) 2005 Kari Laitinen

//  http://www.naturalprogramming.com

//  2005-01-25  Tiedosto luotu.
//  2005-01-25  Viimeisin muutos.

//  compile: csc Kalentereita.cs Paivamaara.cs

using System ;

class  SuomalainenKalenteri
{
   protected  int  tama_kuukausi ;
   protected  int  tama_vuosi ;

   protected  string[]  kuukausien_nimet ;
   protected  string    viikon_kuvaus ;

   public SuomalainenKalenteri() {}

   public SuomalainenKalenteri( int annettu_kuukausi, int annettu_vuosi )
   {
      string[]  suomalaiset_kuukausien_nimet  =  

         { "Tammikuu", "Helmikuu", "Maaliskuu", "Huhtikuu",
           "Toukokuu", "Kesakuu", "Heinakuu", "Elokuu",
           "Syyskuu", "Lokakuu", "Marraskuu", "Joulukuu" } ;

      string  suomalainen_viikon_kuvaus  =

          "Viikko  Ma   Ti   Ke   To   Pe   La   Su" ;

      kuukausien_nimet   =  suomalaiset_kuukausien_nimet ;

      viikon_kuvaus  =  suomalainen_viikon_kuvaus ;

      tama_kuukausi  =  annettu_kuukausi ;
      tama_vuosi     =  annettu_vuosi  ;
   }


   public void tulosta()
   {
      Paivamaara  paiva_tassa_kuussa  = 
                     new  Paivamaara( 1, tama_kuukausi, tama_vuosi ) ;

      int viikonpaivan_indeksi   =  0 ;
      int ensimmaisen_paivan_viikonpaiva  =
                          paiva_tassa_kuussa.viikonpaivan_indeksi() ;

      Console.Write(
            "\n\n   "  +  kuukausien_nimet[ tama_kuukausi - 1 ]
         +  "  "  +  tama_vuosi  +  "\n\n"  +  viikon_kuvaus   +  "\n\n" 
         +  paiva_tassa_kuussa.laske_viikkonumero().ToString().PadLeft( 4 ) 
         +  "  " ) ;

      //  Ensimmainen kuukauden viikko on usein epataydellinen viikko,
      //  eli viikon alkupaivat kuuluvat edelliseen kuukauteen.
      //  Edelliseen kuukauteen kuuluvien paivien tilalle
      //  tulostetaan valilyonteja.

      while ( viikonpaivan_indeksi  !=  ensimmaisen_paivan_viikonpaiva )
      {
         Console.Write( "     " )  ;
         viikonpaivan_indeksi  ++ ;
      }

      while ( tama_kuukausi  ==  paiva_tassa_kuussa.kuukausi() )
      {
         if ( viikonpaivan_indeksi  >=  7 )
         {
            Console.Write( "\n"  + 
              paiva_tassa_kuussa.laske_viikkonumero().ToString().PadLeft( 4 )
              +  "  ") ;

            viikonpaivan_indeksi  =  0 ;
         }

         Console.Write( paiva_tassa_kuussa.paiva().ToString().PadLeft( 5 ) ) ;

         paiva_tassa_kuussa.kasvata() ;

         viikonpaivan_indeksi  ++  ;
      }

      Console.Write( "\n" ) ;
   }
}



class  EspanjalainenKalenteri  :  SuomalainenKalenteri
{
   public EspanjalainenKalenteri( int annettu_kuukausi, int annettu_vuosi )
   {
      string[]  espanjalaiset_kuukausien_nimet  =

         { "Enero", "Febrero", "Marzo", "Abril",
           "Mayo", "Junio", "Julio", "Agosto",
           "Septiembre", "Octubre", "Noviembre", "Deciembre" } ;

      string   espanjalainen_viikon_kuvaus  =

           "Semana  Lun  Mar  Mie  Jue  Vie  Sab  Dom" ;

      kuukausien_nimet  =  espanjalaiset_kuukausien_nimet ;
      viikon_kuvaus     =  espanjalainen_viikon_kuvaus ;

      tama_kuukausi  =  annettu_kuukausi ;
      tama_vuosi     =  annettu_vuosi  ;
   }
}


class  Kalentereita
{
   static void Main()
   {
      SuomalainenKalenteri  eras_suomalainen_kalenteri  =
                                 new  SuomalainenKalenteri( 2, 2008 ) ;

      eras_suomalainen_kalenteri.tulosta() ;

      EspanjalainenKalenteri  eras_espanjalainen_kalenteri  =
                                  new  EspanjalainenKalenteri( 5, 2012 ) ;

      eras_espanjalainen_kalenteri.tulosta() ;
   }
}


